/*
              __  _____  _______ __  _____   ____ ___  ___
             /  |/  / / / / ___// / / /__ \ / __ \__ \<  /
            / /|_/ / / / /\__ \/ /_/ /__/ // / / /_/ // / 
           / /  / / /_/ /___/ / __  // __// /_/ / __// /  
          /_/  /_/\____//____/_/ /_//____/\____/____/_/   

    Copyright (C) 2021  MatCat

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.

*/

#include <cstdio>
#include <string>
#include <cstring>
#include <vector>
#include <cstdint>
#include <algorithm>
#include "classes.hpp"

using namespace std;
/*
                                ________    ___   __________ ___________
                               / ____/ /   /   | / ___/ ___// ____/ ___/
                              / /   / /   / /| | \__ \\__ \/ __/  \__ \ 
                             / /___/ /___/ ___ |___/ /__/ / /___ ___/ / 
                             \____/_____/_/  |_/____/____/_____//____/  
                     
        
   _________________________________________________________________________________________________
  /        ↓               ↓               ↓               ↓               ↓               ↓        \
*/                                                                                          

void BaseObject::printName() {
    printf("Name: %s (#%X)\n",Name.c_str(),ID);
}

void BaseObject::SetVariable(string var, string val) {
    for (auto i = Variables.begin() ; i != Variables.end(); i++) {
        if (i->Name == var) {
            i->Value = val;
            return;
        }
    }
    VariableVector v_v;
    v_v.Name = var;
    v_v.Value = val;
    Variables.push_back(v_v);
}
string BaseObject::getVariable(string var) {
    for (auto i = Variables.begin() ; i != Variables.end(); i++) {
        if (i->Name == var) return i->Value;
    }
    return (string) NULL;
}

void UserObject::printUserInfo() {
    this->printName();
    printf("Inside of: %s (#%X)\nPassword: %s\n",Container->Name.c_str(),Container->ID,Password.c_str());
}


/*
  \________↑_______________↑_______________↑_______________↑_______________↑_______________↑________/
    END OF SECTION: CLASSES                                                                        /
  ________________________________________________________________________________________________/
*/
